// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'NdbAlert.pas' rev: 6.00

#ifndef NdbAlertHPP
#define NdbAlertHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <NdbUtil.hpp>	// Pascal unit
#include <NdbAsa.hpp>	// Pascal unit
#include <NdbBase.hpp>	// Pascal unit
#include <SyncObjs.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <QForms.hpp>	// Pascal unit
#include <Libc.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Ndbalert
{
//-- type declarations -------------------------------------------------------
typedef void __fastcall (__closure *TReceiveEvent)(System::TObject* Sender, const AnsiString MsgName, const AnsiString Msg, int MsgParam);

typedef void __fastcall (__closure *TTimeoutEvent)(System::TObject* Sender, bool &Continue);

#pragma option push -b-
enum TSubscriptionType { mtByNames, mtByUserID, mtByUserIDAndNames };
#pragma option pop

class DELPHICLASS EAsaAlertException;
class PASCALIMPLEMENTATION EAsaAlertException : public Ndbasa::EAsaException 
{
	typedef Ndbasa::EAsaException inherited;
	
public:
	#pragma option push -w-inl
	/* ENativeException.Create */ inline __fastcall EAsaAlertException(const AnsiString Msg, int ErrorCode, int Reserved) : Ndbasa::EAsaException(Msg, ErrorCode, Reserved) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EAsaAlertException(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size) : Ndbasa::EAsaException(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EAsaAlertException(int Ident)/* overload */ : Ndbasa::EAsaException(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EAsaAlertException(int Ident, const System::TVarRec * Args, const int Args_Size)/* overload */ : Ndbasa::EAsaException(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EAsaAlertException(const AnsiString Msg, int AHelpContext) : Ndbasa::EAsaException(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EAsaAlertException(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size, int AHelpContext) : Ndbasa::EAsaException(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EAsaAlertException(int Ident, int AHelpContext)/* overload */ : Ndbasa::EAsaException(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EAsaAlertException(System::PResStringRec ResStringRec, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Ndbasa::EAsaException(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EAsaAlertException(void) { }
	#pragma option pop
	
};


class DELPHICLASS TAsaAlert;
class DELPHICLASS TAsaAlertThread;
class PASCALIMPLEMENTATION TAsaAlertThread : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
private:
	TAsaAlert* FOwner;
	bool FSynchronizing;
	Ndbasa::TAsaSQL* FAsaSQL;
	int FMsgHandle;
	AnsiString FMsgName;
	AnsiString FMsg;
	int FMsgParam;
	AnsiString FLastError;
	int FLastErrorCode;
	void __fastcall CheckToTerminate(AnsiString Error, int ErrorCode, bool SQLError);
	void __fastcall DoReceive(void);
	void __fastcall DoTimeout(void);
	
protected:
	HIDESBASE void __fastcall Synchronize(Classes::TThreadMethod Method);
	virtual void __fastcall Execute(void);
	
public:
	__fastcall TAsaAlertThread(TAsaAlert* AOwner, Ndbasa::TAsaSession* ASession);
	__fastcall virtual ~TAsaAlertThread(void);
	bool __fastcall IsWaiting(void);
	__property bool Synchronizing = {read=FSynchronizing, nodefault};
};


class PASCALIMPLEMENTATION TAsaAlert : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TAsaAlertThread* FAlertThread;
	Syncobjs::TEvent* FAlertWaiting;
	Ndbasa::TAsaSession* FDuplicateSession;
	Ndbasa::TAsaSQL* FAsaSQL;
	AnsiString FMessageNames;
	TSubscriptionType FSubscriptionType;
	int FTimeout;
	TReceiveEvent FOnReceive;
	Classes::TNotifyEvent FOnStopped;
	TTimeoutEvent FOnTimeout;
	AnsiString __fastcall Check(int ErrorCode, bool RaiseException);
	Ndbasa::TAsaSession* __fastcall GetSession(void);
	void __fastcall SetSession(Ndbasa::TAsaSession* ASession);
	void __fastcall ThreadDone(System::TObject* Sender);
	
public:
	__fastcall virtual TAsaAlert(Classes::TComponent* AOwner);
	__fastcall virtual ~TAsaAlert(void);
	void __fastcall Clear(const AnsiString MsgName);
	void __fastcall Send(const AnsiString MsgName, const AnsiString Msg, int MsgParam);
	void __fastcall Start(void);
	bool __fastcall IsWaiting(void);
	AnsiString __fastcall SubscribingFor(void);
	void __fastcall Stop(void);
	
__published:
	__property AnsiString MessageNames = {read=FMessageNames, write=FMessageNames};
	__property TSubscriptionType SubscriptionType = {read=FSubscriptionType, write=FSubscriptionType, nodefault};
	__property Ndbasa::TAsaSession* Session = {read=GetSession, write=SetSession};
	__property int Timeout = {read=FTimeout, write=FTimeout, nodefault};
	__property TReceiveEvent OnReceive = {read=FOnReceive, write=FOnReceive};
	__property Classes::TNotifyEvent OnStopped = {read=FOnStopped, write=FOnStopped};
	__property TTimeoutEvent OnTimeout = {read=FOnTimeout, write=FOnTimeout};
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint NDBALERT_OK = 0x0;
static const Shortint NDBALERT_INVALID_HANDLE = 0xffffffff;
static const Shortint NDBALERT_REQUEST_CANCELLED = 0xfffffffe;
static const Shortint NDBALERT_INVALID_MESSAGE_NAME = 0xfffffffd;
static const Shortint NDBALERT_NO_MESSAGE_WAITING = 0xfffffffc;
static const Shortint NDBALERT_TIMEOUT = 0xfffffffb;
static const Shortint NDBALERT_NO_SUBSCRIBERS = 0xfffffffa;
static const Shortint NDBALERT_SUBSCRIBER_LIMIT_EXCEEDED = 0xfffffff9;
static const Shortint NDBALERT_SUBSCRIBER_TRIAL_LIMIT = 0xfffffff8;
static const Shortint NDBALERT_ILLEGAL_FUNC_CALL = 0xfffffff7;
static const Shortint NDBALERT_UNSPECIFIED_ERROR = 0xfffffff6;
extern PACKAGE System::ResourceString _SNdbAlertInvalidHandle;
#define Ndbalert_SNdbAlertInvalidHandle System::LoadResourceString(&Ndbalert::_SNdbAlertInvalidHandle)
extern PACKAGE System::ResourceString _SNdbAlertRequestCancelled;
#define Ndbalert_SNdbAlertRequestCancelled System::LoadResourceString(&Ndbalert::_SNdbAlertRequestCancelled)
extern PACKAGE System::ResourceString _SNdbAlertInvalidMessageName;
#define Ndbalert_SNdbAlertInvalidMessageName System::LoadResourceString(&Ndbalert::_SNdbAlertInvalidMessageName)
extern PACKAGE System::ResourceString _SNdbAlertNoMessageWaiting;
#define Ndbalert_SNdbAlertNoMessageWaiting System::LoadResourceString(&Ndbalert::_SNdbAlertNoMessageWaiting)
extern PACKAGE System::ResourceString _SNdbAlertTimeout;
#define Ndbalert_SNdbAlertTimeout System::LoadResourceString(&Ndbalert::_SNdbAlertTimeout)
extern PACKAGE System::ResourceString _SNdbAlertNoSubscribers;
#define Ndbalert_SNdbAlertNoSubscribers System::LoadResourceString(&Ndbalert::_SNdbAlertNoSubscribers)
extern PACKAGE System::ResourceString _SNdbAlertSubscriberLimitExceeded;
#define Ndbalert_SNdbAlertSubscriberLimitExceeded System::LoadResourceString(&Ndbalert::_SNdbAlertSubscriberLimitExceeded)
extern PACKAGE System::ResourceString _SNdbAlertTrial;
#define Ndbalert_SNdbAlertTrial System::LoadResourceString(&Ndbalert::_SNdbAlertTrial)
extern PACKAGE System::ResourceString _SNdbAlertIllegalFuncCall;
#define Ndbalert_SNdbAlertIllegalFuncCall System::LoadResourceString(&Ndbalert::_SNdbAlertIllegalFuncCall)
extern PACKAGE System::ResourceString _SNdbAlertUnspecifiedError;
#define Ndbalert_SNdbAlertUnspecifiedError System::LoadResourceString(&Ndbalert::_SNdbAlertUnspecifiedError)
#define NDBALERT_PROC_CLEAR "np_alert_clear"
#define NDBALERT_PROC_CALL_CLEAR "?=call np_alert_clear(?)"
#define NDBALERT_PROC_SEND "np_alert_send"
#define NDBALERT_PROC_CALL_SEND "?=call np_alert_send(?,?,?)"
#define NDBALERT_PROC_SUBSCRIBE "np_alert_subscribe"
#define NDBALERT_PROC_CALL_SUBSCRIBE "?=call np_alert_subscribe(?)"
#define NDBALERT_PROC_RECEIVE "np_alert_receive"
#define NDBALERT_PROC_CALL_RECEIVE "?=call np_alert_receive(?,?,?,?,?)"
#define NDBALERT_PROC_STOP "np_alert_stop"
#define NDBALERT_PROC_CALL_STOP "?=call np_alert_stop(?)"
#define NDBALERT_PROC_UNSUBSCRIBE "np_alert_unsubscribe"
#define NDBALERT_PROC_CALL_UNSUBSCRIBE "?=call np_alert_unsubscribe(?)"
extern PACKAGE void __fastcall Register(void);

}	/* namespace Ndbalert */
using namespace Ndbalert;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// NdbAlert
